Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.fujitsu.iflow.model.workflow
Interface WFObjectList

All Superinterfaces:
  NtfxListener, java.io.Serializable

public interface WFObjectList
extends NtfxListener

The `WFObjectList` interface offers functionality for retrieving lists of the major workflow objects - process definitions, process instances and work items - from the Interstage BPM server. The standard way of constructing a new `WFObjectList` is to call the method `WFObjectFactory.getWFObjectList`.

The lists returned by `WFObjectList` depend on specific criteria as specified by a filter. Built-in filter constants are listed in the API of the `Filter` interface.

To retrieve a list of workflow objects, you must first open the list. You have two possiblities to open a list:

1. batched open (`openBatchedList`)
2. batched open with notification (`openBatchedListWithNotification`)

Using the "batched open" offers the possibility to read the workflow objects via batches and not all at a time. Where large lists may be encountered (more than a few items), it is highly recommended to use the "batched open". Furthermore, the "batched open" supports advanced filtering which means that it is possible to specify a filter to get better results.

The list open operations with notification work in exactly the way as the method without notification, except that they also enable or disable proactive notification.

If the list was opened as "batched" (with or without notification), the objects are retrieved in batches. The supported methods for retrieving the elements are `getNextBatch` and `getPreviousBatch`.

To discard the loaded list, you must close the list after usage in one of the following ways:

1. close (`closeList`)
2. close with notification (`closeListWithNotification`)

It is recommended to use the operation that fits to the used open operation although it is possible to remove the listener of notification by a separate operation using the method `removeWFObjectListListener`.

Sample: openBatchedList

Batched lists offer the possibilities of filtering. If you want to use filtering and sorting when you retrieve your objects in batches, invoke the methods in the following order:

     WFObjectList list = WFObjectFactory.getWFObjectList(session);
     list.addFilter(...);
     list.addSortOrder(...);
     list.openBatchedList(Filter.AllActiveProcesses);
     Object[] procInstList = null;
     int batchSize = 10;
     while ( (procInstList = list.getNextBatch(batchSize)) != null) {
         // process elements in procInstList array use getNextBatch()
     }
     list.closeList();

The `openBatchedList` call should follow `addFilter` and/or `addSortOrder()` call(s) and precede `getNextBatch` calls. If the methods are invoked in any other order, the behaviour of `WFObjectList` is undefined.

Identifying UDAs which are to be used with lists

It is possible to sort and filter workflow objects by User Defined Attributes (UDA). The UDAs which are to be used for filtering/sorting lists must be identified at design time. To do this, add a UDA to the process definition. This UDA should be of String type. The value of this UDA is a comma-separated list of UDA names, which are to be used with lists. The value must be specified at design time as the initial value of the UDA. This value should not be changed once a process is created. The UDAs of the comma- separated list must be marked as 'worklist UDAs' using the method `DataItemRef.markAsWorkListUDA`. If UDAs which are not identified are used to filter/sort lists, the behaviour of the list will be undefined.

The `String` parameters of all methods in this class have a length limit. This limit is documented in the Javadoc comment for every parameter. If the length of a value specified for such a parameter exceeds this limit or the value is `null`, an exception is thrown. This exception is a subclass of the `ModelException` class. For future compatibility, only a `ModelException` should be caught explicitly.

If the signature of a method does not allow the throwing of exceptions, any value supplied to this method that exceeds the length limit is truncated to the maximum length supported. `null` values are ignored in this case. If the behaviour of a method differs from the behaviour described above, it is explained in this method’s Javadoc comment.

Exceptions. Three kinds of exceptions are commonly thrown within this class: `WFServerException`, `WFInternalException`, and `ModelInternalException`, all of which are instances of `ModelException`. In the methods that directly throw a `ModelException`, this exception usually wraps one of the above three exceptions. `WFServerException` indicates that the server failed to operate normally. `WFInternalException` indicates a problem in the communication between client and server. `ModelInternalException` indicates other Model API internal problems.

See Also:
  `WFObjectFactory`, `Filter`, `Plan`, `ProcessInstance`, `WorkItem`

Field Summary
`static int` | `LISTFIELD_PLAN_ID` Identifies the field of the process definition ID that is used to specify a filter for a list.
`static int` | `LISTFIELD_PLAN_IDENTIFIER` Identifies the field of the process definition identifier that is used to filter objects of a specified identifier.
`static int` | `LISTFIELD_PLAN_NAME` Identifies the process definition name list field.
`static int` | `LISTFIELD_PLAN_OWNER` Identifies the field of the process definition owner that is used to filter objects of specified process definition owners.
`static int` | `LISTFIELD_PLAN_STATE` Identifies the field of the process definition state that is used to specify a filter for a list.
`static int` | `LISTFIELD_PROCESSINSTANCE_CLOSEDTIME` Identifies the field of the process instance closing time used to specify the filter for retrieving a list of workflow objects.
`static int` | `LISTFIELD_PROCESSINSTANCE_CREATEDTIME` Identifies the field of the process instance creation time used to specify the filter for retrieving a list of workflow objects.
`static int` | `LISTFIELD_PROCESSINSTANCE_ID` Identifies the process instance ID list field that is used to specify a filter for a list.
`static int` | `LISTFIELD_PROCESSINSTANCE_INITIATOR` Identifies the field of the process instance initiator.
`static int` | `LISTFIELD_PROCESSINSTANCE_NAME` Identifies the field of the process instance's name used to specify the filter for retrieving a list of workflow objects.
`static int` | `LISTFIELD_PROCESSINSTANCE_OWNER` Identifies the field of the process instance's owner used to specify the filter for retrieving a list of workflow objects.
`static int` | `LISTFIELD_PROCESSINSTANCE_PARENTID` Identifies the field of the process instance parent ID used to specify the filter for retrieving a list of workflow objects.
`static int` | `LISTFIELD_PROCESSINSTANCE_PRIORITY` Identifies the field of the process instance priority used to specify the filter for retrieving a list of elements.
`static int` | `LISTFIELD_PROCESSINSTANCE_STATE` Identifies the field of a process instance state that is used to filter objects where the process instance state has a specified value.
`static int` | `LISTFIELD_PROCESSINSTANCE_TITLE` Identifies the field of the process instance's title used to specify the filter for retrieving a list of workflow objects.
`static int` | `LISTFIELD_WORKITEM_ACTIVITYINSTANCEID` Identifies the field of the node instance ID (activity ID) the work item belongs to.
`static int` | `LISTFIELD_WORKITEM_ASSIGNEE` Identifies the field of the work item's assignee used to specify the filter for retrieving a list of workflow objects.
`static int` | `LISTFIELD_WORKITEM_CREATEDTIME` Identifies the field of the work item's creation time used to specify the filter for retrieving a list of workflow objects.
`static int` | `LISTFIELD_WORKITEM_DUEDATE` Identifies the field of the work item's due date used to specify the filter for retrieving a list of workflow objects.
`static int` | `LISTFIELD_WORKITEM_ID` Identifies the field of the work item's ID used to specify the filter for retrieving a list of workflow objects.
`static int` | `LISTFIELD_WORKITEM_NAME` Identifies the field of the work item's name used to specify the filter for retrieving a list of workflow objects.
`static int` | `LISTFIELD_WORKITEM_PRIORITY` Identifies the field of the work item's priority used to specify the filter for retrieving a list of workflow objects.
`static int` | `LISTFIELD_WORKITEM_STATE` Identifies the field of the work item's state used to specify the filter for retrieving a list of workflow objects.
`static boolean` | `SORTORDER_ASCENDING` Indicates that the sort order of the current list is ascending.
`static boolean` | `SORTORDER_DESCENDING` Indicates that the sort order of the current list is descending.
`static java.lang.String` | `SQLOP_EQUALTO` Identifies the 'equal to' (=) operator that is used for SQL queries.
`static java.lang.String` | `SQLOP_GREATERTHAN` Identifies the 'greater than' (>) operator that is used for SQL queries.
`static java.lang.String` | `SQLOP_GREATERTHANOREQUALTO` Identifies the 'greater than or equal to' (>=) operator that is used for SQL queries.
`static java.lang.String` | `SQLOP_IN` Identifies the 'in' operator that is used for SQL queries.
`static java.lang.String` | `SQLOP_LESSTHAN` Identifies the 'less than' (<) operator that is used for SQL queries.
`static java.lang.String` | `SQLOP_LESSTHANOREQUALTO` Identifies the 'less than or equal to' (<=) operator that is used for SQL queries.
`static java.lang.String` | `SQLOP_LIKE` Identifies the 'like' operator that is used for SQL queries.
`static java.lang.String` | `SQLOP_NOTEQUALTO` Identifies the 'not equal' (!=) operator that is used for SQL queries.
`static java.lang.String` | `SQLOP_NOTLIKE` Identifies the 'not like' operator that is used for SQL queries.

Method Summary
`void` | `addFilter(int listField, java.lang.String sqlOperator, java.lang.String value)` Adds a field-based filtering criteria for the list of the objects to be retrieved.
`void` | `addFilter(java.lang.String udaName, java.lang.String udaType, java.lang.String sqlOperator, java.lang.String value)` Adds a User Defined Attributes (UDA) based filtering criteria for the list of the objects to be retrieved.
`void` | `addSortOrder(int listField, boolean sortOrder)` Adds a field-based sort order for the list of objects to be retrieved.
`void` | `addSortOrder(java.lang.String udaName, java.lang.String udaType, boolean sortOrder)` Adds a UDA-based sort order for the list of objects to be retrieved.
`void` | `addWFObjectListListener(WFObjectListListener listener)` Adds the listener to the list of listeners to receive notifications.
`void` | `close(WFObjectListListener listener)` Deprecated. Use method `closeListWithNotification(WFObjectListListener)` instead
`void` | `closeList()` Closes the retrieved list.
`void` | `closeListWithNotification(WFObjectListListener listener)` Closes the retrieved list and unregisters the listener from the list notification listeners.
`int` | `estimateCount()` Returns the number of items currently in the database which match the filters specified for this list.
`java.lang.Object[]` | `getAllObjects()` Deprecated. replaced by `openBatchedList(int)` and `getNextBatch(long, int)`
`java.lang.Object[]` | `getNextBatch(int batchSize)` Returns an array of list objects that are next in sequence.
`java.lang.Object[]` | `getNextBatch(long startId, int howMany)` Returns the next batch of objects, starting with the defined ID.
`java.lang.Object` | `getObject(long id)` Deprecated. This method is only supported in normal list mode. Instead of using the normal list mode it is recommended to use the batched mode.
`java.lang.Object[]` | `getPreviousBatch(long endId, int howMany)` Returns the previous batch of objects, ending at `endId`.
`void` | `openBatchedList(int filter)` Sets up the list to retrieve objects in batches.
`void` | `openBatchedListWithNotification(int filter, WFObjectListListener listener)` Sets up the list to retrieve objects in batches with proactive notification.
`void` | `openList(int filter)` Deprecated. use method `openList(int, String, String, String)` instead
`void` | `openList(int filter, java.lang.String planIdentifier, java.lang.String planName, java.lang.String processInstanceName)` Deprecated. Use `openBatchedList(int)` instead.
`void` | `openListWithNotification(int filter, java.lang.String planIdentifier, java.lang.String planName, java.lang.String processInstanceName, WFObjectListListener listener)` Deprecated. Use `openBatchedListWithNotification(int, com.fujitsu.iflow.model.event.WFObjectListListener)` instead.
`void` | `openListWithNotification(int filter, WFObjectListListener listener)` Deprecated. use method `openListWithNotification(int, String, String, String, WFObjectListListener)` instead
`void` | `receivedNtfx(NtfxEvent event)` Deprecated. The returned elements are always fetched from database and therefore always up to date. This means a listener is no longer necessary.
`void` | `removeWFObjectListListener(WFObjectListListener listener)` Unregisters the listener from the list of notification listeners.

Field Detail

### LISTFIELD_PLAN_ID

    public static final int LISTFIELD_PLAN_ID

  Identifies the field of the process definition ID that is used to specify a filter for a list. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_PLAN_STATE

    public static final int LISTFIELD_PLAN_STATE

  Identifies the field of the process definition state that is used to specify a filter for a list. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_PLAN_NAME

    public static final int LISTFIELD_PLAN_NAME

  Identifies the process definition name list field. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_PLAN_IDENTIFIER

    public static final int LISTFIELD_PLAN_IDENTIFIER

  Identifies the field of the process definition identifier that is used to filter objects of a specified identifier. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_PLAN_OWNER

    public static final int LISTFIELD_PLAN_OWNER

  Identifies the field of the process definition owner that is used to filter objects of specified process definition owners. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_PROCESSINSTANCE_ID

    public static final int LISTFIELD_PROCESSINSTANCE_ID

  Identifies the process instance ID list field that is used to specify a filter for a list. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_PROCESSINSTANCE_STATE

    public static final int LISTFIELD_PROCESSINSTANCE_STATE

  Identifies the field of a process instance state that is used to filter objects where the process instance state has a specified value. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_PROCESSINSTANCE_INITIATOR

    public static final int LISTFIELD_PROCESSINSTANCE_INITIATOR

  Identifies the field of the process instance initiator. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_PROCESSINSTANCE_PRIORITY

    public static final int LISTFIELD_PROCESSINSTANCE_PRIORITY

  Identifies the field of the process instance priority used to specify the filter for retrieving a list of elements. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_PROCESSINSTANCE_CREATEDTIME

    public static final int LISTFIELD_PROCESSINSTANCE_CREATEDTIME

  Identifies the field of the process instance creation time used to specify the filter for retrieving a list of workflow objects. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_PROCESSINSTANCE_CLOSEDTIME

    public static final int LISTFIELD_PROCESSINSTANCE_CLOSEDTIME

  Identifies the field of the process instance closing time used to specify the filter for retrieving a list of workflow objects. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_PROCESSINSTANCE_NAME

    public static final int LISTFIELD_PROCESSINSTANCE_NAME

  Identifies the field of the process instance's name used to specify the filter for retrieving a list of workflow objects. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_PROCESSINSTANCE_TITLE

    public static final int LISTFIELD_PROCESSINSTANCE_TITLE

  Identifies the field of the process instance's title used to specify the filter for retrieving a list of workflow objects. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_PROCESSINSTANCE_PARENTID

    public static final int LISTFIELD_PROCESSINSTANCE_PARENTID

  Identifies the field of the process instance parent ID used to specify the filter for retrieving a list of workflow objects. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_WORKITEM_ID

    public static final int LISTFIELD_WORKITEM_ID

  Identifies the field of the work item's ID used to specify the filter for retrieving a list of workflow objects. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_WORKITEM_ASSIGNEE

    public static final int LISTFIELD_WORKITEM_ASSIGNEE

  Identifies the field of the work item's assignee used to specify the filter for retrieving a list of workflow objects. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_WORKITEM_STATE

    public static final int LISTFIELD_WORKITEM_STATE

  Identifies the field of the work item's state used to specify the filter for retrieving a list of workflow objects. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_WORKITEM_CREATEDTIME

    public static final int LISTFIELD_WORKITEM_CREATEDTIME

  Identifies the field of the work item's creation time used to specify the filter for retrieving a list of workflow objects. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_WORKITEM_PRIORITY

    public static final int LISTFIELD_WORKITEM_PRIORITY

  Identifies the field of the work item's priority used to specify the filter for retrieving a list of workflow objects. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_WORKITEM_NAME

    public static final int LISTFIELD_WORKITEM_NAME

  Identifies the field of the work item's name used to specify the filter for retrieving a list of workflow objects. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_WORKITEM_ACTIVITYINSTANCEID

    public static final int LISTFIELD_WORKITEM_ACTIVITYINSTANCEID

  Identifies the field of the node instance ID (activity ID) the work item belongs to. This field is used to specify the filter for retrieving a list of workflow objects. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_PROCESSINSTANCE_OWNER

    public static final int LISTFIELD_PROCESSINSTANCE_OWNER

  Identifies the field of the process instance's owner used to specify the filter for retrieving a list of workflow objects. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### LISTFIELD_WORKITEM_DUEDATE

    public static final int LISTFIELD_WORKITEM_DUEDATE

  Identifies the field of the work item's due date used to specify the filter for retrieving a list of workflow objects. It can be used only with certain filters.

  See Also:
    `addFilter(int, String, String)`, Constant Field Values

### SQLOP_EQUALTO

    public static final java.lang.String SQLOP_EQUALTO

  Identifies the 'equal to' (=) operator that is used for SQL queries.

  See Also:
    `addFilter(int, String, String)`, `addFilter(String, String, String, String)`, Constant Field Values

### SQLOP_GREATERTHAN

    public static final java.lang.String SQLOP_GREATERTHAN

  Identifies the 'greater than' (>) operator that is used for SQL queries.

  See Also:
    `addFilter(int, String, String)`, `addFilter(String, String, String, String)`, Constant Field Values

### SQLOP_LESSTHAN

    public static final java.lang.String SQLOP_LESSTHAN

  Identifies the 'less than' (<) operator that is used for SQL queries.

  See Also:
    `addFilter(int, String, String)`, `addFilter(String, String, String, String)`, Constant Field Values

### SQLOP_GREATERTHANOREQUALTO

    public static final java.lang.String SQLOP_GREATERTHANOREQUALTO

  Identifies the 'greater than or equal to' (>=) operator that is used for SQL queries.

  See Also:
    `addFilter(int, String, String)`, `addFilter(String, String, String, String)`, Constant Field Values

### SQLOP_LESSTHANOREQUALTO

    public static final java.lang.String SQLOP_LESSTHANOREQUALTO

  Identifies the 'less than or equal to' (<=) operator that is used for SQL queries.

  See Also:
    `addFilter(int, String, String)`, `addFilter(String, String, String, String)`, Constant Field Values

### SQLOP_NOTEQUALTO

    public static final java.lang.String SQLOP_NOTEQUALTO

  Identifies the 'not equal' (!=) operator that is used for SQL queries.

  See Also:
    `addFilter(int, String, String)`, `addFilter(String, String, String, String)`, Constant Field Values

### SQLOP_LIKE

    public static final java.lang.String SQLOP_LIKE

  Identifies the 'like' operator that is used for SQL queries. This operator is not supported for numeric fields.

  See Also:
    `addFilter(int, String, String)`, `addFilter(String, String, String, String)`, Constant Field Values

### SQLOP_NOTLIKE

    public static final java.lang.String SQLOP_NOTLIKE

  Identifies the 'not like' operator that is used for SQL queries. This operator is not supported for numeric fields.

  See Also:
    `addFilter(int, String, String)`, `addFilter(String, String, String, String)`, Constant Field Values

### SQLOP_IN

    public static final java.lang.String SQLOP_IN

  Identifies the 'in' operator that is used for SQL queries.

  See Also:
    `addFilter(int, String, String)`, `addFilter(String, String, String, String)`, Constant Field Values

### SORTORDER_ASCENDING

    public static final boolean SORTORDER_ASCENDING

  Indicates that the sort order of the current list is ascending.

  See Also:
    `addSortOrder(int, boolean)`, Constant Field Values

### SORTORDER_DESCENDING

    public static final boolean SORTORDER_DESCENDING

  Indicates that the sort order of the current list is descending.

  See Also:
    `addSortOrder(int, boolean)`, Constant Field Values

Method Detail

### getObject

    public java.lang.Object getObject(long id)

  Deprecated. This method is only supported in normal list mode. Instead of using the normal list mode it is recommended to use the batched mode.

  Returns the object of the current list that matches the supplied ID. Depending on the current filter, the returned object can be a process definition (`Plan` object), process instance (`ProcessInstance` object) or a work item (`WorkItem` object). Returns `null` if no workflow object was found for supplied id.

  Note, this method is only supported if the current list is opened in normal mode via the method `openList`. In all other cases an error is logged and `null` is returned.

  Parameters:
    `id` - The ID of the object to be returned.
  Returns:
    The object that matches the ID.

### getAllObjects

    public java.lang.Object[] getAllObjects()

  Deprecated. replaced by `openBatchedList(int)` and `getNextBatch(long, int)`

  Returns an array of all workflow objects matching the filter set with the method `openList` or `openListWithNotification`. Depending on the defined filter, the returned objects can be process definitions (`Plan` objects), process instances (`ProcessInstance` objects) or work items (`WorkItem` objects).

  The list must be opened before calling this method. Otherwise `null` is returned. This method is not supported if the list was opened as "batched".

  The usage of this method is only useful if the number of elements that can be returned is small. Use the "batched open" (for example, `openBatchedList(int)`) and the "batched read" (for example, `getNextBatch(int)`) if the number of elements that match the filter can be large.

  Note, this method is only supported if the current list is opened in normal mode via the method `openList`. In all other cases an error is logged and `null` is returned.

  Returns:
    The workflow objects matching the pre-defined filter
  See Also:
    `openList(int, String, String, String)`, `openListWithNotification(int, String, String, String, WFObjectListListener)`

### openListWithNotification

    public void openListWithNotification(int filter,
                                         WFObjectListListener listener)
                                  throws ModelInternalException,
                                         WFInternalException,
                                         WFServerException

  Deprecated. use method `openListWithNotification(int, String, String, String, WFObjectListListener)` instead

  Retrieves the workflow objects for the specified filter and adds the supplied listener to the list of notification listeners.

  Throws:
    `ModelInternalException`
    `WFInternalException`
    `WFServerException`

### openList

    public void openList(int filter)
                  throws ModelInternalException,
                         WFInternalException,
                         WFServerException

  Deprecated. use method `openList(int, String, String, String)` instead

  Retrieves the workflow objects matching the filter from the server.

  Throws:
    `ModelInternalException`
    `WFInternalException`
    `WFServerException`

### openList

    public void openList(int filter,
                         java.lang.String planIdentifier,
                         java.lang.String planName,
                         java.lang.String processInstanceName)
                  throws ModelInternalException,
                         WFInternalException,
                         WFServerException

  Deprecated. Use `openBatchedList(int)` instead.

  Retrieves a list of `WorkItem` objects from the server, matching the filter and having the specified identifier, process definition name, and process instance name.

  This call is only supported for the following work item filters:

  - `Filter.AllWorkItems`
  - `Filter.MyWorkItems`
  - `Filter.MyAcceptedWorkItems`
  - `Filter.MyDeclinedWorkItems`
  - `Filter.MyActiveWorkItems`
  - `Filter.AllInactiveWorkItems`

  If one or more of the parameters `planIdentifier`, `planName` and `processInstanceName` is empty or `null`, it/they will be excluded from the filitering criteria.

  The identifier of the process definition is limited to the number of characters specified by the constant `Plan.MAX_PLAN_IDENTIFIER_LENGTH`. The process definition's name must not be longer than specified in `Plan.MAX_PLAN_NAME_LENGTH`. The maximum length of the process instance name is limited to the number specified by the constant `ProcessInstance.MAX_PROCESS_NAME_LENGTH`

  Parameters:
    `filter` - The integer constant that specifies the type of filtering. See the list of allowed filters above.
    `planIdentifier` - The process definition's identifier.
    `planName` - The process definition's name the searched work items belong to.
    `processInstanceName` - The process instance's name the searched work items belong to.
  Throws:
    `ModelInternalException` - Thrown if any other filter is specified or if one of the parameters `planIdentifier`, `planName` and `processInstanceName` is invalid or `null`. Should be caught as `ModelException` for future compatibility.
    `WFInternalException`
    `WFServerException`
  See Also:
    `Filter`

### openListWithNotification

    public void openListWithNotification(int filter,
                                         java.lang.String planIdentifier,
                                         java.lang.String planName,
                                         java.lang.String processInstanceName,
                                         WFObjectListListener listener)
                                  throws ModelInternalException,
                                         WFInternalException,
                                         WFServerException

  Deprecated. Use `openBatchedListWithNotification(int, com.fujitsu.iflow.model.event.WFObjectListListener)` instead.

  Retrieves a list of `WorkItem` objects from the server, matching the filter and having the specified identifier, process definition name, and process instance name. In addition, adds the supplied listener to the list of listeners to receive notifications.

  This call is only supported for the following work item filters:

  - `Filter.AllWorkItems`
  - `Filter.MyWorkItems`
  - `Filter.MyAcceptedWorkItems`
  - `Filter.MyDeclinedWorkItems`
  - `Filter.MyActiveWorkItems`
  - `Filter.AllInactiveWorkItems`

  If one ore more of the parameters `planIdentifier`, `planName` and `processInstanceName` is empty or `null`, it/they will be excluded from the filitering criteria.

  A list that is opened with notification should be closed by closeListWithNotification

  .

  The identifier of the process definition is limited to the number of characters specified by the constant `Plan.MAX_PLAN_IDENTIFIER_LENGTH`. The process definition's name must not be longer than specified in `Plan.MAX_PLAN_NAME_LENGTH`. The maximum length of the process instance name is limited to the number specified by the constant `ProcessInstance.MAX_PROCESS_NAME_LENGTH`

  Parameters:
    `filter` - The integer constant that specifies the type of filtering. See the list of allowed filters above.
    `planIdentifier` - The process definition's identifier.
    `planName` - The process definition's name the searched work items belong to.
    `processInstanceName` - The process instance's name the searched work items belong to.
    `listener` - The listener object which registers with the server for receiving notifications.
  Throws:
    `ModelInternalException` - Thrown if any other filter is specified or if one of the parameters `planIdentifier`, `planName` and `processInstanceName` is invalid or `null`. Should be caught as `ModelException` for future compatibility.
    `WFInternalException`
    `WFServerException`
  See Also:
    `Filter`, `closeListWithNotification(WFObjectListListener)`, `removeWFObjectListListener(WFObjectListListener)`

### closeList

    public void closeList()
                   throws WFInternalException,
                          WFServerException

  Closes the retrieved list.

  Throws:
    `WFInternalException`
    `WFServerException`
  See Also:
    `openBatchedList(int)`

### close

    public void close(WFObjectListListener listener)
               throws WFInternalException,
                      WFServerException

  Deprecated. Use method `closeListWithNotification(WFObjectListListener)` instead

  Unregisters the listener from the list of notification listeners.

  Throws:
    `WFInternalException`
    `WFServerException`

### closeListWithNotification

    public void closeListWithNotification(WFObjectListListener listener)
                                   throws WFInternalException,
                                          WFServerException

  Closes the retrieved list and unregisters the listener from the list notification listeners.

  Parameters:
    `listener` - The listener object to be removed.
  Throws:
    `WFInternalException`
    `WFServerException`
  See Also:
    `addWFObjectListListener(WFObjectListListener)`, `openBatchedListWithNotification(int, WFObjectListListener)`

### addWFObjectListListener

    public void addWFObjectListListener(WFObjectListListener listener)

  Adds the listener to the list of listeners to receive notifications. The added listener only receives notification if the list is opened with notification.

  Note, notificaition is only supported when the current list was opened in normal mode via the method `openList`. Therefore this method is only supported in that case and in all other cases an error is logged and nothing will be done.

  Parameters:
    `listener` - The listener object which registers with the server for receiving notifications.
  See Also:
    `openBatchedListWithNotification(int, WFObjectListListener)`

### removeWFObjectListListener

    public void removeWFObjectListListener(WFObjectListListener listener)

  Unregisters the listener from the list of notification listeners.

  Note, this method is only supported if the current list is opened in normal mode via the method `openList`. In all other cases an error is logged and nothing will be done.

  Parameters:
    `listener` - The listener object to be removed.

### receivedNtfx

    public void receivedNtfx(NtfxEvent event)

  Deprecated. The returned elements are always fetched from database and therefore always up to date. This means a listener is no longer necessary.

  Method to receive proactive notification. This is the method which is called by `NtfxAdapter` when it receives proactive notification from the server.

  `WFObjectList` needs to handle three types of objects: `WorkItem`, `Plan` and `ProcessInstance`. Each of them needs latest update from the server.

  Note, this method is only supported if the current list is opened in normal mode via the method `openList`. In all other cases an error is logged and nothing will be done.

  Specified by:
    `receivedNtfx` in interface `NtfxListener`

### openBatchedList

    public void openBatchedList(int filter)
                         throws ModelInternalException,
                                WFInternalException,
                                WFServerException

  Sets up the list to retrieve objects in batches. The objects can be retrieved using the method `getNextBatch` and/or `getPreviousBatch`.

  Parameters:
    `filter` - The type of filter as defined in the `Filter` interface by a constant such as `Filter.AllActiveProcesses`
  Throws:
    `ModelInternalException`
    `WFInternalException`
    `WFServerException`
  See Also:
    `getNextBatch(int)`, `getNextBatch(long, int)`, `getPreviousBatch(long, int)`

### openBatchedListWithNotification

    public void openBatchedListWithNotification(int filter,
                                                WFObjectListListener listener)
                                         throws ModelInternalException,
                                                WFInternalException,
                                                WFServerException

  Sets up the list to retrieve objects in batches with proactive notification. The objects can be retrieved using the method `getNextBatch` and/or `getPreviousBatch`.

  A list that is opened with notification should be closed by the method `closeListWithNotification`

  .

  Parameters:
    `filter` - The type of filter as defined in the `Filter` interface by a constant such as `Filter.AllActiveProcesses`
  Throws:
    `ModelInternalException`
    `WFInternalException`
    `WFServerException`
  See Also:
    `getNextBatch(int)`, `getNextBatch(long, int)`, `getPreviousBatch(long, int)`, `closeListWithNotification(WFObjectListListener)`, `removeWFObjectListListener(WFObjectListListener)`

### getNextBatch

    public java.lang.Object[] getNextBatch(long startId,
                                           int howMany)
                                    throws ModelInternalException,
                                           WFInternalException,
                                           WFServerException

  Returns the next batch of objects, starting with the defined ID.

  The returned array size is equal to or less than the defined `howMany` parameter depending on the found number of elements matching the specified filter and the number of elements where the ID is greater than or equal to the `startId` parameter. Returns `null` if there are no more elements in the list to return.

  This method is only supported if the list was opened as batched before calling this method.

  The batch size is restricted to 1-2000.

  Parameters:
    `startId` - The ID (including) from where the returned list starts.
    `howMany` - The maximum number of objects to be returned.
  Returns:
    The next list of workflow objects with regard to the specified filter. An empty list if no more elements are found.
  Throws:
    `ModelInternalException` - Thrown when the `batchSize` exceeds the specified limits or the list is not open. Should be caught as `ModelException` for future compatibility.
    `WFInternalException`
    `WFServerException`
  See Also:
    `openBatchedList(int)`, `openBatchedListWithNotification(int, WFObjectListListener)`

### getPreviousBatch

    public java.lang.Object[] getPreviousBatch(long endId,
                                               int howMany)
                                        throws ModelInternalException,
                                               WFInternalException,
                                               WFServerException

  Returns the previous batch of objects, ending at `endId`.

  The returned array size is equal to or less than the defined `howMany` parameter depending on the found number of elements matching the specified filter and where the ID is less than or equal to the `endId` parameter. Returns `null` if there are no more elements in the list to return.

  This method is only supported if the list was opened as "batched" before calling this method.

  The batch size is restricted to 1-2000.

  Parameters:
    `endId` - The greatest ID of an object the returned list contains.
    `howMany` - The maximum number of objects to be returned.
  Returns:
    The previous list of workflow objects with regard to the specified filter. An empty list if no more elements are found.
  Throws:
    `ModelInternalException` - Thrown when the `batchSize` exceeds the specified limits or the list is not open. Should be caught as `ModelException` for future compatibility.
    `WFInternalException`
    `WFServerException`
  See Also:
    `openBatchedList(int)`, `openBatchedListWithNotification(int, WFObjectListListener)`

### addFilter

    public void addFilter(int listField,
                          java.lang.String sqlOperator,
                          java.lang.String value)
                   throws ModelInternalException

  Adds a field-based filtering criteria for the list of the objects to be retrieved.

  The values passed in the parameters conceptually translate to:
  "where <actual-column-name-of-the-listField> <actual-value-of-the-SQL-operator> '<value>' ".

  Adding a filter is part of advanced filtering used in batched list. The `listField` parameter (see Parameters section below) should be valid in the context of the filter used in `openBatchedList(int)` or `openBatchedListWithNotification(int, WFObjectListListener)` call. The list field searching is not supported for following filters and an exception will be thrown if defined:

  - `Filter.MyCompletedWorkItems`

  Note, when the property SupportGroupWorkItem is set to true in the ibpm.properties, the filter `Filter.MyActiveWorkItems` is not supported.

  The following table identifies the fields that are valid with a particular filter:

  Filter | listField
  --- | ---
  Filter.AllPlans, Filter.MyPlans | LISTFIELD_PLAN_ID, LISTFIELD_PLAN_NAME, LISTFIELD_PLAN_OWNER, LISTFIELD_PLAN_STATE, LISTFIELD_PLAN_IDENTIFIER
  Filter.AllProcesses, Filter.AllActiveProcesses, Filter.MyProcesses, Filter.MyActiveProcesses, Filter.MyInactiveProcesses, Filter.AllInactiveProcesses, Filter.AllProcessesInErrorState | LISTFIELD_PLAN_ID, LISTFIELD_PLAN_NAME, LISTFIELD_PLAN_IDENTIFIER, LISTFIELD_PROCESSINSTANCE_ID, LISTFIELD_PROCESSINSTANCE_STATE, LISTFIELD_PROCESSINSTANCE_INITIATOR, LISTFIELD_PROCESSINSTANCE_PRIORITY, LISTFIELD_PROCESSINSTANCE_NAME, LISTFIELD_PROCESSINSTANCE_TITLE, LISTFIELD_PROCESSINSTANCE_PARENTID, LISTFIELD_PROCESSINSTANCE_CREATEDTIME, LISTFIELD_PROCESSINSTANCE_CLOSEDTIME, LISTFIELD_PROCESSINSTANCE_OWNER
  Filter.AllWorkItems, Filter.AllInactiveWorkItems, Filter.MyWorkItems, Filter.MyAcceptedWorkItems, Filter.MyActiveWorkItems, Filter.MyDeclinedWorkItems | LISTFIELD_PLAN_ID, LISTFIELD_PLAN_NAME, LISTFIELD_PLAN_IDENTIFIER, LISTFIELD_PROCESSINSTANCE_ID, LISTFIELD_PROCESSINSTANCE_STATE, LISTFIELD_PROCESSINSTANCE_NAME, LISTFIELD_PROCESSINSTANCE_TITLE, LISTFIELD_PROCESSINSTANCE_INITIATOR, LISTFIELD_PROCESSINSTANCE_PRIORITY, LISTFIELD_PROCESSINSTANCE_CREATEDTIME, LISTFIELD_WORKITEM_ID, LISTFIELD_WORKITEM_RESPONSIBLE, LISTFIELD_WORKITEM_STATE, LISTFIELD_WORKITEM_CREATEDTIME, LISTFIELD_WORKITEM_DUEDATE, LISTFIELD_WORKITEM_PRIORITY, LISTFIELD_WORKITEM_NAME, LISTFIELD_WORKITEM_ACTIVITYINSTANCEID
  Filter.AllArchivedPlans | LISTFIELD_PLAN_ID, LISTFIELD_PLAN_NAME
  Filter.AllArchivedProcesses | LISTFIELD_PLAN_ID, LISTFIELD_PROCESSINSTANCE_ID, LISTFIELD_PROCESSINSTANCE_NAME,

  For a single opening of a batched list, only one of the filters can be defined; however, it is possible to add an additional User Defined Attribute filter with the method `addFilter(String, String, String, String)`.

  Parameters:
    `listField` - One of the `WFObjectList.LISTFIELD_*` constants, representing the field to be used for filtering the list.
    `sqlOperator` - One of the `WFObjectList.SQLOP_*` constants, representing an SQL operation.
    `value` - A String representation of the value that will be used in conjunction with the `listField`'s column name and SQL operator.
  Throws:
    `ModelInternalException` - Thrown when the supplied sqlOperator can not be applied for data type of list field. Should be caught as `ModelException` for future compatibility.
  See Also:
    `Filter`

### addFilter

    public void addFilter(java.lang.String udaName,
                          java.lang.String udaType,
                          java.lang.String sqlOperator,
                          java.lang.String value)
                   throws ModelInternalException

  Adds a User Defined Attributes (UDA) based filtering criteria for the list of the objects to be retrieved.

  The values passed in the parameters conceptually translate to "where '<udaName>' <actual-value-of-the-SQL-operator> '<value>' ".

  Adding a filter is part of advanced filtering which is only supported in batched list. The UDA that is used for filtering must be marked as 'Work List UDA' by using the method `DataItemRef.markAsWorkListUDA(boolean)`, otherwise a `null` list will be returned. UDA searching and sorting are only valid for processes and work items. It is not valid for process definitions since the UDA values table is only populated by processes. Thus, you cannot use process definition filters for UDA searching. Furthermore, the following filters are not supported for UDA searching and sorting:

  - `Filter.AllArchivedProcesses`
  - `Filter.MyCompletedWorkItems`

  Note, when the property SupportGroupWorkItem is set to true in the ibpm.properties, the filter `Filter.MyActiveWorkItems` is not supported.

  As a summary, UDA searching and sorting is supported for the following filters:

  Process Instance:

  - `Filter.AllProcesses`
  - `Filter.AllActiveProcesses`
  - `Filter.AllInactiveProcesses`
  - `Filter.AllProcessesInErrorState`
  - `Filter.MyProcesses`
  - `Filter.MyActiveProcesses`
  - `Filter.MyInactiveProcesses`

  Work Item:

  - `Filter.AllWorkItems`
  - `Filter.AllInactiveWorkItems`
  - `Filter.MyWorkItems`
  - `Filter.MyActiveWorkItems`
  - `Filter.MyAcceptedWorkItems`
  - `Filter.MyDeclinedWorkItems`

  For a single opening of a batched list, only one UDA filter can be defined; it is, however, possible to add an additional list field filter with the method `addFilter(int, String, String)`.

  The UDA's name must not be longer than specified in `DataItemRef.MAX_DATA_REF_NAME_LENGTH`.

  Parameters:
    `udaName` - The UDA's name to be used to filter the list.
    `udaType` - The type of UDA as defined in the `DataItemRef` interface by a constant such as `DataItemRef.TYPE_STRING`
    `sqlOperator` - One of the `WFObjectList.SQLOP_*` constants, representing a SQL operation.
    `value` - A String representation of the value that will be used in conjunction with the UDA's name and SQL operator.
  Throws:
    `ModelInternalException` - Thrown when the supplied name is invalid or `null`. Furthermore this exception is thrown if the supplied sqlOperator can not be applied for the uda data type. Should be caught as `ModelException` for future compatibility.
  See Also:
    `Filter`, `openBatchedList(int)`, `openBatchedListWithNotification(int, WFObjectListListener)`

### addSortOrder

    public void addSortOrder(int listField,
                             boolean sortOrder)
                      throws ModelInternalException

  Adds a field-based sort order for the list of objects to be retrieved.

  Adding a sort order is part of advanced filtering which is used in batched list. The `listField` parameter (see Parameters section below) should be valid in the context of the filter used in the `openBatchedList(int)` or `openBatchedListWithNotification(int, WFObjectListListener)` call.

  The following table identifies the list fields that are valid with a particular filter:

  Filter | listField
  --- | ---
  Filter.AllPlans, Filter.MyPlans | LISTFIELD_PLAN_ID, LISTFIELD_PLAN_NAME, LISTFIELD_PLAN_OWNER, LISTFIELD_PLAN_STATE, LISTFIELD_PLAN_IDENTIFIER
  Filter.AllProcesses, Filter.AllActiveProcesses, Filter.MyProcesses, Filter.MyActiveProcesses, Filter.MyInactiveProcesses | LISTFIELD_PLAN_ID, LISTFIELD_PLAN_NAME, LISTFIELD_PLAN_IDENTIFIER, LISTFIELD_PROCESSINSTANCE_ID, LISTFIELD_PROCESSINSTANCE_STATE, LISTFIELD_PROCESSINSTANCE_INITIATOR, LISTFIELD_PROCESSINSTANCE_PRIORITY, LISTFIELD_PROCESSINSTANCE_NAME, LISTFIELD_PROCESSINSTANCE_TITLE, LISTFIELD_PROCESSINSTANCE_PARENTID, LISTFIELD_PROCESSINSTANCE_CREATEDTIME, LISTFIELD_PROCESSINSTANCE_CLOSEDTIME
  Filter.AllInactiveProcesses | LISTFIELD_PLAN_NAME, LISTFIELD_PLAN_IDENTIFIER, LISTFIELD_PROCESSINSTANCE_ID, LISTFIELD_PROCESSINSTANCE_STATE, LISTFIELD_PROCESSINSTANCE_INITIATOR, LISTFIELD_PROCESSINSTANCE_PRIORITY, LISTFIELD_PROCESSINSTANCE_NAME, LISTFIELD_PROCESSINSTANCE_TITLE, LISTFIELD_PROCESSINSTANCE_PARENTID, LISTFIELD_PROCESSINSTANCE_CREATEDTIME, LISTFIELD_PROCESSINSTANCE_CLOSEDTIME
  Filter.AllProcessesInErrorState | LISTFIELD_PLAN_NAME, LISTFIELD_PLAN_IDENTIFIER, LISTFIELD_PROCESSINSTANCE_ID, LISTFIELD_PROCESSINSTANCE_STATE, LISTFIELD_PROCESSINSTANCE_INITIATOR, LISTFIELD_PROCESSINSTANCE_PRIORITY, LISTFIELD_PROCESSINSTANCE_NAME, LISTFIELD_PROCESSINSTANCE_TITLE, LISTFIELD_PROCESSINSTANCE_PARENTID, LISTFIELD_PROCESSINSTANCE_CREATEDTIME
  Filter.AllWorkItems, Filter.AllInactiveWorkItems, Filter.MyWorkItems, Filter.MyAcceptedWorkItems, Filter.MyActiveWorkItems, Filter.MyDeclinedWorkItems | LISTFIELD_PLAN_ID, LISTFIELD_PLAN_NAME, LISTFIELD_PLAN_IDENTIFIER, LISTFIELD_PROCESSINSTANCE_ID, LISTFIELD_PROCESSINSTANCE_STATE, LISTFIELD_PROCESSINSTANCE_NAME, LISTFIELD_PROCESSINSTANCE_TITLE, LISTFIELD_PROCESSINSTANCE_INITIATOR, LISTFIELD_PROCESSINSTANCE_PRIORITY, LISTFIELD_PROCESSINSTANCE_CREATEDTIME, LISTFIELD_WORKITEM_DUEDATE, LISTFIELD_WORKITEM_ID, LISTFIELD_WORKITEM_RESPONSIBLE, LISTFIELD_WORKITEM_STATE, LISTFIELD_WORKITEM_CREATEDTIME, LISTFIELD_WORKITEM_PRIORITY, LISTFIELD_WORKITEM_NAME, LISTFIELD_WORKITEM_ACTIVITYINSTANCEID
  Filter.MyCompletedWorkItems | LISTFIELD_WORKITEM_NAME
  Filter.AllArchivedPlans | LISTFIELD_PLAN_ID
  Filter.AllArchivedProcesses | LISTFIELD_PROCESSINSTANCE_ID

  Parameters:
    `listField` - One of the `WFObjectList.LISTFIELD_*` constants, representing the field to be used to filter the list.
    `sortOrder` - One of the `WFObjectList.SORTORDER_*` constants, representing the type that is used to sort the list.
  Throws:
    `ModelInternalException`
  See Also:
    `Filter`

### addSortOrder

    public void addSortOrder(java.lang.String udaName,
                             java.lang.String udaType,
                             boolean sortOrder)
                      throws ModelInternalException

  Adds a UDA-based sort order for the list of objects to be retrieved.

  Adding a sort order is part of advanced filtering which is only supported in batched list. The UDA that is used for filtering must be marked as 'WorkList UDA' by using the method `DataItemRef.markAsWorkListUDA(boolean)`, otherwise a `null` list will be returned. UDA searching and sorting are only valid for processes and work items. It is not valid for process definitions since the UDA values table is only populated by processes. Thus, you cannot use process definition filters for UDA searching. In addition, the following filters are not supported for UDA searching and sorting:

  - `Filter.AllArchivedProcesses`
  - `Filter.MyCompletedWorkItems`

  Summarizing, the UDA sorting is supported for following filters:

  Process Instance:

  - `Filter.AllProcesses`
  - `Filter.AllActiveProcesses`
  - `Filter.AllInactiveProcesses`
  - `Filter.AllProcessesInErrorState`
  - `Filter.MyProcesses`
  - `Filter.MyActiveProcesses`
  - `Filter.MyInactiveProcesses`

  Work Item:

  - `Filter.AllWorkItems`
  - `Filter.AllInactiveWorkItems`
  - `Filter.MyWorkItems`
  - `Filter.MyActiveWorkItems`
  - `Filter.MyAcceptedWorkItems`
  - `Filter.MyDeclinedWorkItems`

  The UDA's name must not be longer than specified in `DataItemRef.MAX_DATA_REF_NAME_LENGTH`.

  Parameters:
    `udaName` - The UDA's name to be used to filter the list.
    `udaType` - The type of UDA as defined in the `DataItemRef` interface by a constant such as `DataItemRef.TYPE_STRING`
    `sortOrder` - One of the `WFObjectList.SORTORDER_*` constants, representing the type that is used to sort the list.
  Throws:
    `ModelInternalException` - Thrown when the supplied name is invalid or `null`. Should be caught as `ModelException` for future compatibility.
  See Also:
    `Filter`, `openBatchedList(int)`, `openBatchedListWithNotification(int, WFObjectListListener)`

### getNextBatch

    public java.lang.Object[] getNextBatch(int batchSize)
                                    throws ModelInternalException,
                                           WFInternalException,
                                           WFServerException

  Returns an array of list objects that are next in sequence.

  The returned array size is equal to or less than the defined `batchSize` parameter depending on the found number of elements matching the specified filter. Returns `null` if there are no more elements in the list to return.

  This method is only supported if the list was opened as "batched" before calling this method.

  The batch size is restricted to 1 - 2000.

  Parameters:
    `batchSize` - The maximum number of objects to be returned.
  Returns:
    The next list of workflow objects with regard to the specified filter or `null` if no more elements are found.
  Throws:
    `ModelInternalException` - Thrown when the `batchSize` exceeds the specified limits or the list is not open. Should be caught as `ModelException` for future compatibility.
    `WFInternalException`
    `WFServerException`
  See Also:
    `openBatchedList(int)`, `openBatchedListWithNotification(int, WFObjectListListener)`

### estimateCount

    public int estimateCount()
                      throws ModelInternalException

  Returns the number of items currently in the database which match the filters specified for this list. This number is an estimate of the number of items which will be retrieved from the list using the `getNextBatch(int)` method. It is an estimate because a different number of items may be retrieved if objects which match the criteria for this list are added or removed between the invokation of this method and the retrieval of objects from the list. For the same reason, successive invokations of this method on the same list may return different values.

  This method can be called only after the list has been opened by calling one of the methods:

  - `openBatchedList(int)`
  - `openBatchedListWithNotification(int, WFObjectListListener)`
  and before the list is closed by calling one of the methods:
  - `closeList()`
  - `closeListWithNotification(WFObjectListListener)`

  Returns:
    The number of items currently in the database which match the filters specified for this list.
  Throws:
    `ModelInternalException` - Thrown when the list is not opened as "batched" or is closed. Should be caught as `ModelException` for future compatibility.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD